# Foundation State Machine

[![lerna](https://img.shields.io/badge/maintained%20with-lerna-cc00ff.svg)](https://lerna.js.org/)
[![TypeScript](https://img.shields.io/badge/%3C%2F%3E-TypeScript-%230074c1.svg)](https://www.typescriptlang.org/)

State machines in `foundation-ui` are built upon the [xState](https://github.com/statelyai/xstate) v5+ library and provide bindable properties and other hooks. `foundation-state-machine` provides a collection of pre-built state machines and utilities to build your own machines.

For details on how machines work see the API Docs and the v5+ version of the [xstate docs](https://stately.ai/docs/xstate-v5). 

### Pre-built state machines

Overtime this package will provide a number of pre-built machines that offer common functionality. Visit their README files and API Docs for more information.

* [FetchMachine](./src/machines/fetch/README.md)
* ...

Domain focused machines like `AuthMachine` will live in different packages.


## Installation

To enable this module in your application, follow the steps below.

1. Add `@genesislcap/foundation-state-machine` as a dependency in your `package.json` file. Whenever you change the dependencies of your project, ensure you run the `$ npm run bootstrap` command again. You can find more information in the [package.json basics](https://learn.genesis.global/secure/web/basics/package-json-basics/) page.

```json
{
  ...
  "dependencies": {
    ...
    "@genesislcap/foundation-state-machine": "latest"
    ...
  },
  ...
}
```

## [API Docs](./docs/api/index.md)

## License

Note: this project provides front-end dependencies and uses licensed components listed in the next section; thus, licenses for those components are required during development. Contact [Genesis Global](https://genesis.global/contact-us/) for more details.

### Licensed components
Genesis low-code platform
